#include "stdio.h"

// Load Soap Client header generated from WSDL
#include "soapH.h"
// Load namespace map
#include "AGMS_USCOREAPISoap.nsmap"

int main()
{
  // Initialise Soap Client
  struct soap soap;
  soap_init(&soap);

  // Initialise request
  struct _ns1__ProcessTransaction request;
  struct ns1__Params params;
  // Assign request parameters
  params.GatewayUserName = "your username";
  params.GatewayPassword = "your password";
  params.TransactionType = "sale";
  params.PaymentType = "creditcard";
  params.Amount = "1.00";
  params.CCNumber = "4111111111111111";
  params.CCExpDate = "0120";
  params.CVV = "123";
  
  // Assign params to objparameters
  request.objparameters = &params;

  // printf("%s\n", request.objparameters.CVV);
  
  // Initialised Response
  struct _ns1__ProcessTransactionResponse response; 
  
  // You will find in the soapClient.c file the prototype of the remote procedure you want to consume (in bold below)
  if(soap_call___ns1__ProcessTransaction(&soap, 
    NULL, 
    NULL, 
    &request, 
    &response
    )== SOAP_OK){

    printf("Status Code: %s\n", response.ProcessTransactionResult->STATUS_USCORECODE);
    printf("Status Message: %s\n", response.ProcessTransactionResult->STATUS_USCOREMSG);
    printf("Status Message: %s\n", response.ProcessTransactionResult->TRANS_USCOREID);
  }
  else

    soap_print_fault(&soap, stderr); 

  soap_destroy(&soap); 
  soap_end(&soap); 
  soap_done(&soap); 

  return 0;

}